gsapp.controller('titleCtrl', ['titler', '$scope', '$window',
    function (titler, $scope, $window) {
		$scope.titler = titler;

		$scope.$on('SOLO', function (e) {
			$scope.teamEvent = false;
		});


		$scope.$on('TEAM', function (e) {
			$scope.teamEvent = true;
		});
}]);

// The viewOptions controller is used in the
// root level display for the app. Currently
// it has no functionality but is here just
// in case.
gsapp.controller('viewOptions', ['titler', '$scope', '$window',
    function (titler, $scope, $window) {

		titler.setTitle('Home');


		// This function updates the title of the page being viewed after
		// angular has processed the new title.  If this function is removed
		// all of the page titles seen in google analytics will be the same.
		// I am told this matters for SEO.
		$scope.$on('$viewContentLoaded', function (event) {
			$window.ga('send', 'pageview', {
				'title': titler.title()
			});
		});

}]);

// The teamDisplay controller is used in the
// display of the team members view
//
// TODO each individual memeber of the
// team's score should be fetched for
// this view
gsapp.controller('teamDisplay', ['$scope', '$routeParams', 'GS', 'titler', '$window', '$timeout', 'sillyGolf', 'statData',
    function ($scope, $routeParams, GS, titler, $window, $timeout, sillyGolf, statData) {

		$scope.tournName = $routeParams.tournName;

		// This callback sets the rounds we have
		// data for and triggers the rdChange
		// function to display each round when we
		// determine we have data for it. Making
		// sure that the final round we have
		// data for is displayed.
		setRdCount = function (data) {
			$scope.round = data;
			GS.getPlayerScores(setTeamScores, $routeParams.tournID, $routeParams.team, $scope.round);
		}




		// The GS service is used to set the rounds
		// the setRdCount callback is called for each
		// round we have data for.
		GS.getRoundCount($routeParams.tournID, setRdCount);

		$scope.teamScores = {};
		$scope.players = [];

		// callback function for the GS service
		setTeamScores = function (data, rnd) {
			//			console.log(data);
			$scope.logoPath = 'http://golfstatresults.com/images/schoollogos/' + data[0].TEAM_ID + ".jpg";
			angular.forEach(data, function (value, key) {
				data[key].PLAYER_SEED = $scope.playerInfo(value.PLAYER_CONTACT_ID, 'PLAYER_SEED');
				$scope.players[$scope.players.length] = {
					playerID: value.PLAYER_CONTACT_ID
				};
			});
			$scope.teamScores[rnd] = data;
			$scope.pscores = {};
			angular.forEach(data, function (val, key) {
				this[val.PLAYER_CONTACT_ID] = val;
			}, $scope.pscores);
		}

		$scope.tournID = $routeParams.tournID;


		// The sillyGolf object has a method for setting a players par to E if
		// the score is 0, and another for setting the players completed holes
		// to F if they have completed 18 holes.
		$scope.sg = sillyGolf;

		// ORIGINAL FUNCTION

		// callback function for the GS service
		setTeam = function (data) {
			titler.setTitle(data[0].TEAM_NAME + ' @ ' + data[0].TOURNAMENT_DESCR);
			$scope.team = data;
		}

		GS.getPlayers(setTeam, $routeParams.tournID, $routeParams.team);

		// END ORIGINAL FUNCTION

		// This function updates the title of the page being viewed after
		// angular has processed the new title.  If this function is removed
		// all of the page titles seen in google analytics will be the same.
		// I am told this matters for SEO.
		$scope.$on('$viewContentLoaded', function (event) {
			$timeout(function () {
				$window.ga('send', 'pageview', {
					'title': titler.title()
				});
			}, 800);
		});

		// playerInfo will return any part of the players info entered into thing
		$scope.playerInfo = function (pcID, thing) {
			var p = '';
			angular.forEach($scope.team, function (value, key) {
				if (value.PLAYER_CONTACT_ID == pcID) {
					p = value;
				}
			});
			if (p.PARTICIPATE_AS_INDIVIDUAL_CD === 'Y') p.PLAYER_SEED = 'INDV';
			return p[thing];
		};


		$scope.totals = function (round) {
			var ins = {
				'distance': 0,
				'par': 0,
				'score': 0,
				'topar': 0
			},
				out = {
					'distance': 0,
					'par': 0,
					'score': 0,
					'topar': 0
				},
				total = {
					'distance': 0,
					'par': 0,
					'score': 0,
					'topar': 0
				};
			angular.forEach(round, function (hole) {
				if (hole.HOLE > 9) {
					ins.distance = ins.distance + hole.YARDAGE;
					ins.par = ins.par + hole.PAR;
					ins.score = ins.score + hole.TOTAL_STROKE_COUNT;
					ins.topar = ins.topar + hole.TOPAR;
				} else if (hole.HOLE < 10) {
					out.distance = out.distance + hole.YARDAGE;
					out.par = out.par + hole.PAR;
					out.score = out.score + hole.TOTAL_STROKE_COUNT;
					out.topar = out.topar + hole.TOPAR;
				}

				total.distance = total.distance + hole.YARDAGE;
				total.par = total.par + hole.PAR;
				total.score = total.score + hole.TOTAL_STROKE_COUNT;
				total.topar = total.topar + hole.TOPAR;

			});

			if (ins.topar == 0)
				ins.topar = "E";
			if (out.topar == 0)
				out.topar = "E";
			if (total.topar == 0)
				total.topar = "E";

			return {
				'in': ins,
				'out': out,
				'total': total
			};
		};

		// The topar function determines a
		// players distance to par over the
		// round cumulatively
		$scope.topar = function (round, current) {
			var topar = 0;
			if (round[0].START_HOLE_NUMBER == 1) {
				angular.forEach(round, function (hole) {
					if (hole.HOLE <= current) {
						topar = topar + hole.TOPAR;
					}
				});
			} else {
				var holedata = {};
				var start = round[0].START_HOLE_NUMBER;

				angular.forEach(round, function (hole) {
					holedata[hole.HOLE] = hole.TOPAR;
				});

				if (current < start) {
					//  The number of holes that get added before  the start of the ongoing numbers?
					iterator = 19 - start
					// equals 8 on a hole start of 11

					//This is working well, just not adding correctly for the second thing...
					for (var i = 0; i < iterator; i++) {
						topar = topar + holedata[i + start];
					}

					// top = the start through current hole
					for (var i = 1; i <= current; i++) {
						topar = topar + holedata[i];
					}
				} else {
					iterator = (current - start) + 1
					for (var i = 0; i < iterator; i++) {
						topar = topar + holedata[i + start];
					}
				}
			}
			if (topar == 0) topar = "E"
			return topar;
		};

		// The shotCaller function determines
		// the type of score achieved on each
		// hole according to golf's standard
		// scoring. The results are used to
		// determine the class of each table
		// data element containing a score.
		$scope.shotstart = function (hole) {
			if (hole.START_HOLE_NUMBER === hole.HOLE) {
				return "starting-hole";
			}
		};

		// The shotCaller function determines
		// the type of score achieved on each
		// hole according to golf's standard
		// scoring. The results are used to
		// determine the class of each table
		// data element containing a score.
		$scope.shotcaller = function (hole) {

			if (hole.TOPAR > 0) {
				if (hole.TOPAR > 1) {
					return "double-bogey";
				}
				return "bogey";
			} else if (hole.TOPAR < 0) {
				if (hole.TOPAR < -1) {
					return "eagle";
				}
				return "birdie";
			}
			return "par";
		};





}]);

// The tournDisplay controller displays each
// tournament beginning (I think) in the time
// period (default is today and back 30 days).
// These tournaments are filtered by what kind
// of tournament they are.
// TODO find out what kind of delimiting data
// can be used to sort the junior and amateur
// tournaments out of the rest
gsapp.controller('tournDisplay', ['$scope', '$routeParams', '$timeout', 'GS', 'titler', '$window', 'statData', '$interval',
    function ($scope, $routeParams, $timeout, GS, titler, $window, statData, $interval) {

		var filters = {
			'M': 'Men\'s College Tournaments',
			'W': 'Women\'s College Tournaments',
			'B': 'Amateur Tournaments',
			'J': 'High School Tournaments'
		};

		// This is the starting date which can be
		// changed in the popup menu
		$scope.start = 15;

		// This function responds to a change in
		// the start date when it is selected from
		// the menu.
		$scope.setStart = function (num) {
			if (num != $scope.start) {
				$scope.start = num;
				$scope.settings = !$scope.settings;
				GS.getTourn(setTourn, GS.Day.backXdays($scope.start), GS.Day.forwardXdays(0));
			}
		};
		// Retrieve the filter from the routeparams
		$scope.filter = $routeParams.filter;
		$scope.filterName = filters[$scope.filter];

		titler.setTitle(filters[$scope.filter]);


		$scope.tourneyFilter = function (tourney) {
			return tourney.GENDER === $scope.filter && tourney.LIVE_SCORING === 1;
		};

		// callback function for the GS service
		setTourn = function (data) {
			$scope.tournaments = data;
		};

		$scope.tournLinky = function (data) {
			if (data.GENDER === 'B' || data.GENDER === 'J') {
				return '#/players/' + $routeParams.filter + '/' + data.TOURNAMENT_ID + '/' + data.TOURNAMENT_DESCR + '/';
			}
			return '#/tournaments/' + $routeParams.filter + '/' + data.TOURNAMENT_ID + '/' + data.TOURNAMENT_DESCR + '/';
		};

		GS.getTourn(setTourn, GS.Day.backXdays($scope.start), GS.Day.forwardXdays(0));

		// This function fires after the list of
		// tournaments is (hopefully) done
		// loading. When fired it resizes the
		// holding div of the list to fit the
		// screen real estate available
		$scope.listDone = function () {
			$timeout(function () {
				var screenspace = (window.innerHeight - 130) + 'px';
				document.getElementById('scrollArea').style.maxHeight = screenspace;
			}, 200);
		};

		// This function updates the title of the page being viewed after
		// angular has processed the new title.  If this function is removed
		// all of the page titles seen in google analytics will be the same.
		// I am told this matters for SEO.
		$scope.$on('$viewContentLoaded', function (event) {
			$timeout(function () {
				$window.ga('send', 'pageview', {
					'title': titler.title()
				});
			}, 800);
		});

}]);

// The resultDisplay controller fetches the
// results for the selected tournament for display.
// These results are broken up by rounds which are
// fetched individually.
gsapp.controller('resultDisplay', ['$scope', '$routeParams', 'GS', '$timeout', '$location', 'titler', '$window', 'sillyGolf',
    function ($scope, $routeParams, GS, $timeout, $location, titler, $window, sillyGolf) {

		var tournamentid = $routeParams.tournament;

		// This route is used to link to the player
		// display controller below.
		$scope.playerRoute = "players/" + $location.path().substring(13);

		$scope.results = [];

		var requestedRounds = [];

		// This object will be used for our
		// timeout function. Each round fetched
		// will be re-fetched every 5 minutes.
		// I'm told corrections to past rounds
		// can occur whenever so despite this
		// seeming like a poor choice perhaps it's
		// necessary to keep up with changes.
		// TODO verify the necessity of re fetching
		// all rounds.
		var stopTeam;

		// The callback used by the GS service
		// in the rdChange function below.
		setResults = function (data, theround) {
			// console.log(data);

			if (data.MIN_THRU == 0) {
				$scope.$emit('SOLO');
				$scope.teamEvent = false;
				$location.path($scope.playerRoute).replace();
			} else {
				$scope.$emit('TEAM');
				$scope.teamEvent = true;
			}

			if ($scope.results[theround] == undefined) {
				$scope.results[theround] = data;
				//            if (data[0].FINISHED == "N"){
				//stopTeam = $timeout(function(){
				//    $scope.rdChange(theround);
				//                }, 300000); //<= 5mins * 60secs * 1000ms
				//            }
			}
		}

		$scope.tournName = $routeParams.tournName;

		titler.setTitle($scope.tournName + ' Teams');

		$scope.tournID = tournamentid;
		$scope.round = 0;

		$scope.fetchErr = {
			"msg": []
		};

		var check;
		check = $timeout(function () {
			if ($scope.round == 0) {
				$scope.fetchErr.msg[0] = "We don't appear to have data for this tournament.";
				$scope.fetchErr.msg[1] = "Please check back soon.";
			} else {
				$scope.fetchErr.msg = "";
			}
		}, 2000);

		//$scope.getAd = GS.getAd(668,40);

		setCourseData = function (data) {
			//console.log(data);
			$scope.courseData = data;
		};

		GS.getCourseData($scope.tournID, setCourseData);

		// This callback sets the rounds we have
		// data for and triggers the rdChange
		// function to display each round when we
		// determine we have data for it. Making
		// sure that the final round we have
		// data for is displayed.
		setRdCount = function (data) {
			$scope.roundCount = data;
			$scope.rdChange(data);
		};

		// The GS service is used to set the rounds
		// the setRdCount callback is called for each
		// round we have data for.
		GS.getRoundCount(tournamentid, setRdCount);

		// When a round is selected this function
		// fetches the data for that round.
		$scope.rdChange = function (rnd) {
			$scope.round = rnd;
			GS.getLb(setResults, tournamentid, $scope.round);
		};


		$scope.adText = function (d, ind) {
			// if (ind > 0 && ind % 9 === 0) {
			//     if ($.inArray(d, $window.app.adDivs) === -1) {
			//         $window.app.adDivs.push(d);
			//     }
			// }
		};


		// This function fires after the results
		// are (hopefully) done loading. When
		// fired it resizes the holding div of the
		// results to fit the screen real estate available
		$scope.tableDone = function () {
			$timeout(function () {
				var screenspace = (window.innerHeight - 160) + 'px',
					theScroll;
				//var scrollRnd = 'scrollArea' + $scope.round;
				document.getElementById('scrollArea').style.maxHeight = screenspace;
				if (theScroll === undefined) {
					//theScroll = new iScroll('scrollArea');
				} else {
					//theScroll.refresh();
				}
			}, 200);
		};

		// This function should stop the fetching of the
		// team data when we navigate to a different page
		$scope.$on('$locationChangeStart', function () {
			$timeout.cancel(stopTeam);
		});


		// This function updates the title of the page being viewed after
		// angular has processed the new title.  If this function is removed
		// all of the page titles seen in google analytics will be the same.
		// I am told this matters for SEO.
		$scope.$on('$viewContentLoaded', function (event) {
			$timeout(function () {
				$window.ga('send', 'pageview', {
					'title': titler.title()
				});
			}, 800);
		});

		// The sillyGolf object has a method for setting a players par to E if
		// the score is 0, and another for setting the players completed holes
		// to F if they have completed 18 holes.
		$scope.sg = sillyGolf;


}]);

// The playerDisplay controller fetches the
// results of the tournament by player instead
// of by team but also broken up by round.
gsapp.controller('playerDisplay', ['$scope', '$routeParams', '$timeout', '$location', 'GS', 'titler', '$window', 'sillyGolf',
    function ($scope, $routeParams, $timeout, $location, GS, titler, $window, sillyGolf) {

		var tournamentid = $routeParams.tournament;

		$scope.type = $routeParams.filter;

		// This route is used for navigation back to
		// the Team results display
		$scope.teamRoute = "tournaments/" + $location.path().substring(9);

		$scope.results = [];

		var requestedRounds = [];

		// This object will be used for our
		// timeout function. Each round fetched
		// will be re-fetched every 5 minutes.
		// I'm told corrections to past rounds
		// can occur whenever so despite this
		// seeming like a poor choice perhaps it's
		// necessary to keep up with changes.
		// TODO verify the necessity of re fetching
		// all rounds.
		var stopPlayers;

		// The callback used by the GS service
		// in the rdChange function below.
		setResults = function (data, theround) {
			console.log(data);
			if ($scope.results[theround] == undefined) {
				$scope.results[theround] = data;
				//stopPlayers = $timeout(function(){
				// $scope.rdChange(theround);
				//}, 300000); // 5 minutes
			}
		}

		$scope.tournName = $routeParams.tournName;

		titler.setTitle($scope.tournName + ' Players');

		$scope.tournID = tournamentid;
		$scope.round = 0;

		// This callback sets the rounds we have
		// data for and triggers the rdChange
		// function to display each round when we
		// determine we have data for it. Making
		// sure that the final round we have
		// data for is displayed.
		setRdcount = function (data) {
			$scope.roundCount = data;
			$scope.rdChange(data);
		};

		GS.getRoundCount(tournamentid, setRdcount);

		// When a round is selected this function
		// fetches the data for that round.
		$scope.rdChange = function (rnd) {
			$scope.round = rnd;
			GS.getPlayerLB(setResults, tournamentid, $scope.round);
		};

		// teamName expects player to be an object
		// which can be checked for the smallest
		// name given for the player's team. The
		// first 7 characters of the players team
		// are returned.
		$scope.teamName = function (player) {
			if (player.VERY_SHORT_TEAM_NAME !== null) return player.VERY_SHORT_TEAM_NAME.substring(0, 6);
			if (player.SHORT_TEAM_NAME !== null) return player.SHORT_TEAM_NAME.substring(0, 6);
			return player.TEAM_NAME.substring(0, 6);
		}


		$scope.adText = function (d, ind) {
			// if (ind > 0 && ind % 9 === 0) {
			//     if ($.inArray(d, $window.app.adDivs) === -1) {
			//         $window.app.adDivs.push(d);
			//     }
			// }
		};



		// This function fires after the results
		// are (hopefully) done loading. When
		// fired it resizes the holding div of the
		// results to fit the screen real estate available
		$scope.tableDone = function () {
			$timeout(function () {
				var screenspace = (window.innerHeight - 160) + 'px';
				if (document.getElementById('scrollArea')) {
					document.getElementById('scrollArea').style.maxHeight = screenspace;
				}
			}, 200);
		};

		// This function should stop the fetching of the
		// team data when we navigate to a different page
		$scope.$on('$locationChangeStart', function () {
			$timeout.cancel(stopPlayers);
		});

		// This function updates the title of the page being viewed after
		// angular has processed the new title.  If this function is removed
		// all of the page titles seen in google analytics will be the same.
		// I am told this matters for SEO.
		$scope.$on('$viewContentLoaded', function (event) {
			$timeout(function () {
				$window.ga('send', 'pageview', {
					'title': titler.title()
				});
			}, 800);
		});

		// The sillyGolf object has a method for setting a players par to E if
		// the score is 0, and another for setting the players completed holes
		// to F if they have completed 18 holes.
		$scope.sg = sillyGolf;


		setCourseData = function (data) {
			//console.log(data);
			$scope.courseData = data;
		}

		GS.getCourseData($scope.tournID, setCourseData);


}]);

// The individualDisplay controller is used for
// fetching each round of data for an individual
// golfer at a given tournament.
gsapp.controller('individualDisplay', ['$scope', '$routeParams', '$location', '$timeout', 'GS', 'titler', '$window', 'sillyGolf',
    function ($scope, $routeParams, $location, $timeout, GS, titler, $window, sillyGolf) {

		var tournamentid = $routeParams.tournament;

		var playerID = $routeParams.player;

		$scope.tournName = $routeParams.tournName;
		$scope.tournID = tournamentid;
		$scope.round = 0;

		$scope.results = [];

		var requestedRounds = [];

		// stopIndividual is the timeout function
		// used in the setResults function
		var stopIndividual;

		setResults = function (data, theround) {
			console.log(data);
			if (data) {
				$scope.playerImg = 'http://www.golfstatresults.com/images/players/' + data[0].PLAYER_CONTACT_ID + ".jpg";
				titler.setTitle(data[0].PLAYER + ' @ ' + $scope.tournName);
				$scope.results[theround] = data;
			} else {
				$scope.round = theround - 1;
				$scope.roundCount = theround - 1;
				if (theround > 0) {
					$scope.rdChange(theround - 1);
				} else if (theround == 0) {
					$scope.errMsg = 'Sorry, there appears to be no data for this player.';
				}
			}
		}

		// This callback sets the rounds we have
		// data for and triggers the rdChange
		// function to display each round when we
		// determine we have data for it. Making
		// sure that the final round we have
		// data for is displayed.
		setRdcount = function (data) {
			$scope.roundCount = data;
			$scope.rdChange(data);
		};

		GS.getRoundCount(tournamentid, setRdcount);

		// When a round is selected this function
		// fetches the data for that round.
		$scope.rdChange = function (rnd) {
			$scope.round = rnd;
			GS.getHoles(setResults, playerID, tournamentid, $scope.round);
		};


		// This function fires after the results
		// are (hopefully) done loading. When
		// fired it resizes the holding div of the
		// results to fit the screen real estate available
		$scope.tableDone = function () {
			$timeout(function () {
				var screenspace = (window.innerHeight - 160) + 'px';
				document.getElementById('scrollArea').style.maxHeight = screenspace;
			}, 200);
		};

		// This function should stop the fetching of the
		// team data when we navigate to a different page
		$scope.$on('$locationChangeStart', function () {
			$timeout.cancel(stopIndividual);
		});


		$scope.totals = function (round) {
			var ins = {
				'distance': 0,
				'par': 0,
				'score': 0,
				'topar': 0
			},
				out = {
					'distance': 0,
					'par': 0,
					'score': 0,
					'topar': 0
				},
				total = {
					'distance': 0,
					'par': 0,
					'score': 0,
					'topar': 0
				};
			angular.forEach(round, function (hole) {
				if (hole.HOLE > 9) {
					ins.distance = ins.distance + hole.YARDAGE;
					ins.par = ins.par + hole.PAR;
					ins.score = ins.score + hole.TOTAL_STROKE_COUNT;
					ins.topar = ins.topar + hole.TOPAR;
				} else if (hole.HOLE < 10) {
					out.distance = out.distance + hole.YARDAGE;
					out.par = out.par + hole.PAR;
					out.score = out.score + hole.TOTAL_STROKE_COUNT;
					out.topar = out.topar + hole.TOPAR;
				}

				total.distance = total.distance + hole.YARDAGE;
				total.par = total.par + hole.PAR;
				total.score = total.score + hole.TOTAL_STROKE_COUNT;
				total.topar = total.topar + hole.TOPAR;

			});

			if (ins.topar == 0)
				ins.topar = "E";
			if (out.topar == 0)
				out.topar = "E";
			if (total.topar == 0)
				total.topar = "E";

			return {
				'in': ins,
				'out': out,
				'total': total
			};
		};

		// The topar function determines a
		// players distance to par over the
		// round cumulatively
		$scope.topar = function (round, current) {
			var topar = 0;
			if (round[0].START_HOLE_NUMBER == 1) {
				angular.forEach(round, function (hole) {
					if (hole.HOLE <= current) {
						topar = topar + hole.TOPAR;
					}
				});
			} else {
				var holedata = {};
				var start = round[0].START_HOLE_NUMBER;

				angular.forEach(round, function (hole) {
					holedata[hole.HOLE] = hole.TOPAR;
				});

				if (current < start) {
					//  The number of holes that get added before  the start of the ongoing numbers?
					iterator = 19 - start
					// equals 8 on a hole start of 11

					//This is working well, just not adding correctly for the second thing...
					for (var i = 0; i < iterator; i++) {
						topar = topar + holedata[i + start];
					}

					// top = the start through current hole
					for (var i = 1; i <= current; i++) {
						topar = topar + holedata[i];
					}
				} else {
					iterator = (current - start) + 1
					for (var i = 0; i < iterator; i++) {
						topar = topar + holedata[i + start];
					}
				}
			}
			if (topar == 0) topar = "E"
			return topar;
		};

		// The shotCaller function determines
		// the type of score achieved on each
		// hole according to golf's standard
		// scoring. The results are used to
		// determine the class of each table
		// data element containing a score.
		$scope.shotStart = function (hole) {
			if (hole.START_HOLE_NUMBER === hole.HOLE) {
				return "starting-hole";
			}
		};

		// The shotCaller function determines
		// the type of score achieved on each
		// hole according to golf's standard
		// scoring. The results are used to
		// determine the class of each table
		// data element containing a score.
		$scope.shotCaller = function (hole) {

			if (hole.TOPAR > 0) {
				if (hole.TOPAR > 1) {
					return "double-bogey";
				}
				return "bogey";
			} else if (hole.TOPAR < 0) {
				if (hole.TOPAR < -1) {
					return "eagle";
				}
				return "birdie";
			}
			return "par";
		};

		// finalPlace will hold the player's place
		// up to the specific round
		$scope.finalPlace = '';

		setFinalPlace = function (data) {
			$scope.finalPlace = data;
		}

		GS.getFinalPlace(tournamentid, playerID, setFinalPlace);

		// This function updates the title of the page being viewed after
		// angular has processed the new title.  If this function is removed
		// all of the page titles seen in google analytics will be the same.
		// I am told this matters for SEO.
		$scope.$on('$viewContentLoaded', function (event) {
			$timeout(function () {
				$window.ga('send', 'pageview', {
					'title': titler.title()
				});
			}, 800);
		});


		setCourseData = function (data) {
			console.log(data);
			$scope.courseData = data;
		}

		GS.getCourseData($scope.tournID, setCourseData);

		// The sillyGolf object has a method for setting a players par to E if
		// the score is 0, and another for setting the players completed holes
		// to F if they have completed 18 holes.
		$scope.sg = sillyGolf;

}]);

// The searchDisplay controller is currently
// unused but placed here just in case it needs
// to be used later.
gsapp.controller('searchDisplay', ['$scope', '$routeParams',
	function ($scope, $routeParams) {
		$scope.search = 'nothing';
}]);

// The settingsCtrl controller is currently
// used to determine the status of the settings
// menu and nohting else.
gsapp.controller('settingsCtrl', ['$scope',
	function ($scope) {
		$scope.settings = false;

		$scope.toggleSettings = function () {
			$scope.settings = !$scope.settings;
		}

}]);

gsapp.controller('adCtrl', ['$scope',
	function ($scope) {
		var ord = Date.now();

		$scope.ad = '<a id="adLink" href="http://ad.doubleclick.net/N310322/jump/GolfStat;sz=300x50;ord=' + ord + '?"> <img id="adImg" src="http://ad.doubleclick.net/N310322/ad/GolfStat;sz=300x50;ord=' + ord + '?" width="300" height="50" /></a>';

}]);
