angular.module('project.service', []).
    factory('GS', ['$http', '$timeout', '$q', function($http, $timeout, $q){

            var gsurl = 'http://www.golfstatresults.com/webservices/sec/event.cfc';


            var data = {};

            return {
                    getTourn : function(callback, date1, date2){
                            var payload = {'date1': date1,
                                           'date2': date2,
                                           'method': 'getTournaments', 'UID': 'golfweek',
                                           'PWD':'gsgw13', 'returnFormat': 'JSON'};

                            $http.get(gsurl, { params: payload }).
                                success(function(data, status){
                                    // This block breaks Header / Column data into
                                    // a list of json objects organized by key /value
                                        var stuf = [];
                                        // Loop over each item in the data list
                                        angular.forEach(data.DATA, function(value, key){
                                            var thing = {};
                                            // assign a key to each value in the item
                                            angular.forEach(value, function(value, key){
                                                    if (data.COLUMNS[key] == 'START_DATE') {
                                                       var d = new Date(value);
                                                       this[data.COLUMNS[key]] = d.getTime();
                                                    }
                                                    else if (data.COLUMNS[key] == 'END_DATE') {
                                                        var d = new Date(value);
                                                        this[data.COLUMNS[key]] = d.getTime();
                                                    }
																										else if (data.COLUMNS[key] == 'TOURNAMENT_DESCR') {
																												this[data.COLUMNS[key]] = value.replace(/\//g, '-')
																										}
                                                    else {
                                                       this[data.COLUMNS[key]] = value;
                                                    }
                                                }, thing);
                                                //thing['FINISHED'] = ((thing['END_DATE'] + 24*60*60*1000) < Date.now());
                                                // if (value[10] == 1 && value[11])
                                                //     this.push(thing);
                                                if(thing.LIVE_SCORING && thing.TOURNAMENT_FORMAT_CD != 'P')
                                                    this[this.length] = thing;
                                            }, stuf);
                                        callback(stuf);
                                    });
                        },

                    getTeam : function(callback, tournID){
                            var payload = {'method': 'getTournamentTeams', 'tt_id': teamID,
                                           'UID': 'golfweek', 'tournament_id': tournID,
                                           'PWD':'gsgw13', 'returnFormat': 'JSON'};


                            $http.get(gsurl , {params: payload}).
                                success(function(data,status){
                                        var stuf = [];
                                        callback(data);
                                    });
                        },

                    getPlayers : function(callback, tournID, teamID){
                            var payload = {'method': 'getTournamentPlayers', 'tt_id': teamID,
                                           'UID': 'golfweek', 'tournament_id': tournID,
                                           'PWD':'gsgw13', 'returnFormat': 'JSON'};


                            $http.get(gsurl , {params: payload}).
                                success(function(data,status){
                                        var stuf = [];
                                        angular.forEach(data.DATA, function(value, key){
                                            var thing = {};
                                            // assign a key to each value in the item
                                            angular.forEach(value, function(value, key){
                                                    this[data.COLUMNS[key]] = value;
                                                }, thing);
                                                this.push(thing);
                                            },stuf);
                                        callback(stuf);
                                    });
                        },

                    getLb : function (callback, tournID, round){

                            var roundData = [];

                            var payload = {'method': 'teamLB', 'rd': round,
                                       'UID': 'golfweek', 'tournament_id': tournID,
                                       'PWD':'gsgw13', 'returnFormat': 'JSON'};

                            $http.get(gsurl , {params: payload}).
                                success(function(data,status){
                                        if(data.DATA.length > 0){
                                            // Loop over each item in the data list
                                            angular.forEach(data.DATA, function(value, key){
                                                var thing = {};
                                                // assign a key to each value in the item
                                                angular.forEach(value, function(value, key){
                                                        this[data.COLUMNS[key]] = value;
                                                    }, thing);
                                                    this.push(thing);
                                                }, roundData);
                                        }
                                    callback(roundData, round);
                                    });
                        },

                    getPlayerScores : function(callback, tournID, teamID, round){

                            var roundData = [];

                            var payload = {'method': 'playerLB', 'rd': round,
                                       'UID': 'golfweek', 'tournament_id': tournID,
                                       'PWD':'gsgw13', 'returnFormat': 'JSON'};

                            $http.get(gsurl, {params: payload}).
                                success(function(data, status){
                                        if(data.DATA.length > 0){
                                            // Loop over each item in the data list
                                            angular.forEach(data.DATA, function(value, key){
                                                var thing = {};
                                                // assign a key to each value in the item
                                                angular.forEach(value, function(value, key){
                                                        this[data.COLUMNS[key]] = value;
                                                    }, thing);
                                                    if (thing.TOURNAMENT_TEAM_ID == teamID){
                                                        this.push(thing);
                                                    }
                                                }, roundData);
                                        }
                                    callback(roundData, round);
                                    });
                        },

                    getPlayerLB : function(callback, tournID, round){

                            var roundData = [];

                            var payload = {'method': 'playerLB', 'rd': round,
                                       'UID': 'golfweek', 'tournament_id': tournID,
                                       'PWD':'gsgw13', 'returnFormat': 'JSON'};

                            $http.get(gsurl , {params: payload}).
                                success(function(data,status){
                                        if(data.DATA.length > 0){
                                            // Loop over each item in the data list
                                            angular.forEach(data.DATA, function(value, key){
                                                var thing = {};
                                                // assign a key to each value in the item
                                                angular.forEach(value, function(value, key){
                                                        this[data.COLUMNS[key]] = value;
                                                    }, thing);
                                                    this.push(thing);
                                                }, roundData);
                                        }
                                    callback(roundData, round);
                                    });

                        },

                    getFinalPlace : function(tournID, playerID, callback) {
                            var payload = {'method': 'playerLB', 'pc_id': playerID,
                                       'UID': 'golfweek', 'tournament_id': tournID,
                                       'PWD':'gsgw13', 'returnFormat': 'JSON'};

                            $http.get(gsurl, {params: payload}).
                                success(function(data, status) {
                                    if(data.DATA.length > 0){
                                        //console.log(data.DATA[2]);
                                        callback(data.DATA[0][2]);
                                    }
                                });
                    },

                    getHoles : function(callback, playerID, tournID, round){

                            var roundData = undefined;

                            var payload = {'method': 'playerDetail', 'rd': round,
                                       'pc_id': playerID, 'UID': 'golfweek',
                                       'tournament_id': tournID, 'PWD':'gsgw13',
                                       'returnFormat': 'JSON'};

                            $http.get(gsurl , {params: payload}).
                                success(function (data, status) {
                                        if (data.DATA.length > 0) {
                                            roundData = [];
                                            // Loop over each item in the data list
                                            angular.forEach(data.DATA, function(value, key){
                                                var thing = {};
                                                // assign a key to each value in the item
                                                angular.forEach(value, function(value, key){
                                                        this[data.COLUMNS[key]] = value;
                                                    }, thing);
                                                    this.push(thing);
                                                }, roundData);
                                        }
                                    callback(roundData, round);
                                    });

                        },

                    getRoundCount : function (tournID, callback) {

                            var payload = {'method': 'playerLB',
                                       'UID': 'golfweek', 'tournament_id': tournID,
                                       'PWD':'gsgw13', 'returnFormat': 'JSON'};

                            $http.get(gsurl, {params: payload})
                                    .success(function (data, status) {
                                            if (data.DATA.length > 0) {
                                                callback(parseInt(data.DATA[0][1]));
                                            } else {
                                                callback(0);
                                            }
                                    });


                        },

                    getCourseData : function (tournID, callback) {
                            var payload = {'method': 'tournamentCourses',
                                       'UID': 'golfweek', 'tournament_id': tournID,
                                       'PWD':'gsgw13', 'returnFormat': 'JSON'};


                            $http.get(gsurl, {params: payload})
                                    .success(function (data, status) {
                                        if (data.DATA.length > 0)
                                            callback({'LOCATION': data.DATA[0][0],
                                                'COURSE_URL': data.DATA[0][2], 'COURSE_SETUP_ID': data.DATA[0][1],
                                                'LAYOUT_NAME': data.DATA[0][3], 'ADDRESS': data.DATA[0][4],
                                                'CITY': data.DATA[0][5], 'STATE': data.DATA[0][6],
                                                'ZIP': data.DATA[0][7], 'COUNTRY': data.DATA[0][8],
                                                'TOTALPAR': data.DATA[0][9], 'TOTALYARDS': data.DATA[0][10]
                                            });
                                    });


                    },

                    Day : {
                          today : function(){
                                var d = new Date();
                                return (d.getMonth()+1) + "/" + d.getDate() + "/" + d.getFullYear();
                              },
                          backXdays : function(days){
                                var d = new Date(+new Date - (days * 24 * 60 * 60 * 1000));
                                return (d.getMonth()+1) + "/" + d.getDate() + "/" + d.getFullYear();
                              },
                          forwardXdays : function(days){
                                var d = new Date(+new Date + (days * 24 * 60 * 60 * 1000));
                                return (d.getMonth()+1) + "/" + d.getDate() + "/" + d.getFullYear();
                              }
                        },

                    getAd: function (width, height, index) {

                        if (index > 0 && index % 9 == 0) {
                            console.log(index);
                            var adUrl = 'http://golfweek.com/ad/golfstat/';
                            var ord = Math.floor(Math.random() * 1000) + 1;
                            return 'http://www.lolcats.com';
                            //return adUrl + '?size=' + width + 'x' + height + ';ord=' + ord + ';';
                        }
                        else {
                            return '';
                        }
                    }

                }


        }]).
        config(function($httpProvider){
            delete $httpProvider.defaults.headers.common['X-Requested-With'];
        });
